/*
 *  A simple random number generator.
 *  Invoke with -h flag for usage information.
 *
 *  <C> Copyright 1994 by Emanuel G. Noik
 */

#include <math.h>
#include <stdio.h>

void ShowHelp()
{
   static char *help[] = {
      "rand - a simple random number 'server'",
      "usage:  rand [-i] [-s i] [-min x] [-max y] [-h]",
      "-i      -generate integer-valued numbers (default: floating point)",
      "-s i    -set random number generator seed to (long int)i",
      "-min x  -set minimum value to x",
      "-max y  -set maximum value to y",
      "-h      -display this help information",
      0
   };
   int i;

   for( i = 0; help[i] != 0; i++ )
      printf( "%s\n", help[i] );
}

main( argc, argv )
int argc;
char *argv[];
{
   extern double drand48();
   char buf[80];
   int i, integer = 0;
   long int seed = 1;
   double min =  0;
   double max = 10;

   for( i = 1; i < argc; i++ )
   {
      if(      strcmp( argv[i], "-i"   ) == 0 ) { integer = 1; }
      else if( strcmp( argv[i], "-s"   ) == 0 ) { seed = atoi( argv[i+1] ); }
      else if( strcmp( argv[i], "-min" ) == 0 ) { min = atof( argv[i+1] ); }
      else if( strcmp( argv[i], "-max" ) == 0 ) { max = atof( argv[i+1] ); }
      else if( strcmp( argv[i], "-h"   ) == 0 ) { ShowHelp(); exit( 0 ); }
   }

   if( min >= max )
   {
      min =  0;
      max = 10;
   }

   while( gets(buf) != 0 )
   {
      int i, n;
      if( sscanf( buf, "%d", &n ) != 1 )
         n = 1;
      for( i = 0; i < n; i++ )
      {
         double value = min + ( max - min ) * drand48();
         if( integer )
            printf( "%d ", (int)(value+0.5) );
         else
            printf( "%g ", value );
      }
      printf( "\n" );
      fflush( stdout );
   }

   exit( 0 );
}
